/*
 * Joc de proves de la practica 2
 * Cal assegurar-se de que la practica passa aquest joc de proves
 * abans d'entregar-la.
 */
public class prova2 {


   /*
    * Suposicions fetes:
    * El tipus "org" esta definit a la classe "TAD_org"  
    * amb 2 parametres: 
    * 1) nombre maxim de categories
    * 2) nombre maxim d'albums
    * El tipus "llista_albums" esta definit a la classe "TAD_llista_albums"
    * que proporciona una operacio imprimir_llista() que imprimeix
    * la llista per pantalla.
    * El tipus "llista_cadenes" esta definit a la classe "TAD_llista_cadenes"
    * que proporciona una operacio imprimir_llista() que imprimeix
    * la llista per pantalla.
    * Una altra opcio valida es tenir una llista generica, que implementa l'interface 
    * llista. 

    * Prova: 20 categories, 300 albums
    */
    
    
    /* Suposem que no s'ha canviat la signatura de les ops.
     * Suposem que existeix una operacio imprimir() que mostra el millor posible
     * per pantalla el contingut de l'estructura o (imprescindible per fer jocs de proves !!!)
     */
    
    public static void mostra(org o) {
        o.imprimir();
    }
    
    public static void main (String args[]) throws NoMemoria, PDIdreta, NoArrel, NoExisteix, ElemRepetit {
        
      org o; 
      //private Treball t;
      //private Llista_Treballs l;
    
	/*
	 * Prova: organitzador amb 20 categories i 300 albums 
	 */
      o = new org(20,300);
      
      mostra(o); 
      
      o.afegir_categoria("jazz","musica");
      o.afegir_categoria("rock","musica");
      o.afegir_categoria("pop","musica");
      o.afegir_categoria("pop britanic","pop");
      o.afegir_categoria("blues","jazz");
      o.afegir_categoria("classica","musica");
      o.afegir_categoria("opera","musica");
      o.afegir_categoria("classics","rock");
      o.afegir_categoria("pink floyd","classics");
      o.afegir_categoria("rage","rock");

      //o.afegir_categoria("sardanes", "popular"); // error:categoria pare inexistent
      //o.afegir_categoria("opera","classica");    // error:categoria ja existia
      mostra(o);
  
     /*
      * afegim uns quants albums a l'estructura des de fitxer extern
      * es suposa que al TAD_org tenim una operacio llegir_albums_fitxer()
      * que llegeix els albums del fitxer de text "albums.txt" i els guarda a l'estructura
      */
      
      //o.llegir_albums_fitxer();
      o.afegir_album("rock", new Album("Pu'uhonua"));
      o.afegir_album("classica", new Album("The Dark Side Of The Moon"));
      o.afegir_album("opera", new Album("Luciano Pavarotti in Concert"));
      o.afegir_album("jazz", new Album("American Jazz & Blues History"));
      o.afegir_album("pop", new Album("The Battle of Los Angeles"));
      o.afegir_album("pop", new Album("Revolver"));
      o.afegir_album("rock", new Album("Revolver"));
      o.afegir_album("blues", new Album("American Jazz & Blues History"));
      //o.afegir_album("", new Album("American Jazz & Blues History"));
      
      
      mostra(o);
      
      //fem algunes consultes

      o.albums_categoria("musica").imprimir_albums(); // mostra tots els albums
      o.albums_categoria("jazz").imprimir_albums();
      o.albums_categoria("pop").imprimir_albums();
      o.albums_categoria("pop britanic").imprimir_albums();
      o.albums_categoria("classics").imprimir_albums();
      //o.albums_categoria("ska").imprimir_albums(); // error:categoria inexistent

      o.subcategories("musica").imprimir_cadenes();
      o.subcategories("pop").imprimir_cadenes();
      o.subcategories("pop britanic").imprimir_cadenes();
      o.subcategories("classica").imprimir_cadenes();
      //o.subcategories("reggae").imprimir_cadenes();  //error: categoria inexistent

      o.categories("Pu'uhonua").imprimir_cadenes();
      o.categories("The Dark Side Of The Moon").imprimir_cadenes();
      o.categories("Luciano Pavarotti in Concert").imprimir_cadenes();
      o.categories("American Jazz & Blues History").imprimir_cadenes();
      o.categories("The Battle of Los Angeles").imprimir_cadenes();
      o.categories("Revolver").imprimir_cadenes();
      }
}
